// (C) Timofey S. Chistyakov, 2006
{$apptype console}

uses
  Math;

const
  MUCH_TIME = 1e100;
  
var
  n, k: integer;
  a: array of array of extended;

var
  fi, fo: textfile;
  i, j: integer;
  t, tn: array of extended;
  tl, tr: extended;
  res: extended;
begin
  AssignFile(fi, 'input.txt');
  Reset(fi);
  AssignFile(fo, 'output.txt');
  ReWrite(fo);

  read(fi, n, k);
  SetLength(a, n, k);
  SetLength(t, n);
  SetLength(tn, n);
  for i := 0 to n - 1 do begin
    for j := 0 to k - 1 do
      read(fi, a[i, j]);
    t[i] := 0;
  end;

  for i := 1 to k do begin
    for j := 0 to n - 1 do begin
      if j > 0 then
        tl := t[j - 1]
      else
        tl := MUCH_TIME;
      if j < n - 1 then
        tr := t[j + 1]
      else
        tr := MUCH_TIME;
      tn[j] := 10 / a[j, i - 1] + MinValue([tl, tr, t[j]]);
    end;
    for j := 0 to n - 1 do
      t[j] := tn[j];
  end;

  res := MUCH_TIME;
  for i := 0 to High(t) do
    res := Min(res, t[i]);
  WriteLn(fo, res:0:4);

  CloseFile(fo);
  CloseFile(fi);
end.
