#pragma once
#include <fstream>
#include <stdlib.h>
#include <math.h>
using namespace std;
#define _maxRoadCount 100
#define _maxRoadLength 1000
#define inf 1000000
#define intervalLength 10
int roadCount;
int roadLength;
double roadTime[_maxRoadCount][_maxRoadLength+1];
double roadSpeed[_maxRoadCount][_maxRoadLength];
double mintime=inf;

int main()
{
	ifstream fin;
	fin.open("input.txt",ios::in);
	ofstream fout;
	fout.open("output.txt",ios::out);
	fin>>roadCount;
	fin>>roadLength;
	for(int i=0;i<roadCount;i++)
	{
		for(int j=0;j<roadLength;j++)
		{
			fin>>roadSpeed[i][j];
		}
	}
	for(int i=0;i<roadCount;i++)
	{
		for(int j=0;j<roadLength+1;j++)
		{
			roadTime[i][j]=inf;
		}
	}
	for(int i=0;i<roadCount;i++)
	{
		roadTime[i][0]=0;
	}
	for(int j=0;j<roadLength;j++)
	{
		for(int i=0;i<roadCount;i++)
		{
			if ((i!=0) && (roadTime[i-1][j+1]>roadTime[i][j]+(intervalLength/roadSpeed[i-1][j])))
			{
				roadTime[i-1][j+1]=(roadTime[i][j]+(intervalLength/roadSpeed[i-1][j]));
			}
			if(roadTime[i][j+1]>(roadTime[i][j]+(intervalLength/roadSpeed[i][j])))
			{
				roadTime[i][j+1]=(roadTime[i][j]+(intervalLength/roadSpeed[i][j]));
			}
			if((i!=roadCount-1) && roadTime[i+1][j+1]>(roadTime[i][j]+(intervalLength/roadSpeed[i+1][j])))
			{
				roadTime[i+1][j+1]=(roadTime[i][j]+(intervalLength/roadSpeed[i+1][j]));
			}
		}
	}
	mintime=roadTime[0][roadLength];
	for(int i=1;i<roadCount;i++)
	{
		if(mintime>roadTime[i][roadLength])
		{
			mintime=roadTime[i][roadLength];
		}
	}
	fout<<mintime;
	fin.close();
	fout.close();
	return 0;
}